#!/bin/bash

METHOD=$1

PJSON="$(dirname $0)/pjson"

MYSQL="mysql -sN -unetroot -pnetroot -e "

#Извлечь необходимые параметры из json
#Параметры:
#   $1 - весь json-объект
#   $2 - извлекаемый параметр
#  return JSONVAL_RESULT - необходимый параметр
jsonval() {
	json=$1
	prop=$2
 	test "$json" && JSONVAL_RESULT=$(echo $json| $PJSON $prop)
}

#Сделать запрос GET к локальному кассовому серверу
#Параметры:
#   $1 - URI для GET
#  return CURL_RESULT=запрашиваемые данные при удаче | 0 если запрос не удался (из-за большого таймаута или недоступности сервиса)
cs_curl_request(){
	CS_CURL_GET_URI=$1
	CS_CURL_RESULT=$(curl --connect-timeout 2 --write-out "__answer_code:%{http_code}__" -s "$CS_CURL_GET_URI")
	response_code=$(echo $CS_CURL_RESULT | grep -oE "__answer_code:.*__" | sed s/__answer_code://g | sed s/__//g)
	if [ "$response_code" = "200" ]; then
		CURL_RESULT="$(echo $CS_CURL_RESULT | sed s/__answer_code:.*__//g)"
	else
		CURL_RESULT=0
	fi;
}

case $METHOD in
	exchange.dict.isrunning)
		if [ "$(status exchangers-upload|grep start/running)" ] && 
			[ $(( $(cat /opt/exchangers/config/cs/exchangers.ini|grep 'poolProcessSize'|grep -o '[[:digit:]]\+') + 1 == $(ps ax|grep 'python startS[e]rvice.py'| wc -l))) ]; then 
			echo '1'; 
		else 
			echo '0'; 
		fi;
		;;
	exchange.sale.isrunning)
		if [ "$(status exchangers-unload|grep start/running)" ] && 
			[ "$(ps ax|grep 'python unloa[d]Service.py')" ]; then 
			echo '1'; 
		else 
			echo '0'; 
		fi;
		;;
	nes.isrunning)
		if [ "$(status nes|grep start/running)" ] && 
			[ $(( $(cat /opt/nes/config/nes_load.ini|grep 'poolProcessSize'|grep -o '[[:digit:]]\+') + 1 == $(ps ax|grep 'python loadS[e]rvice.py'| wc -l))) ]; then 
			echo '1'; 
		else 
			echo '0'; 
		fi;
		;;
	sync2.isrunning)
		if [ "$(status sync-core2|grep start/running)" ] && 
			[ "$(ps ax|grep 'python Syn[c]Server.py')" ]; then 
			echo '1'; 
		else 
			echo '0'; 
		fi;
		;;
	qpid.isrunning)
		if [ "$(ps ax|grep qpid)" ] && 
			[ "$(netstat -an|grep 5672.*LISTEN)" ]; then 
			echo '1'; 
		else 
			echo '0'; 
		fi;
		;;
	cs.isrunning)
		if [ $(ps ax|grep v[i]rgo|wc -l) -gt 0 ] && 
			[ "$(netstat -an|grep 8080.*LISTEN)" ] && 
			[ "$(curl  --connect-timeout 1 -s http://localhost:8080/CSrest/rest/system/info |grep buildNumber)" ]; then 
			echo '1'; 
		else 
			echo '0'; 
		fi;
		;;
	mongo.isrunning)
		mongo --eval 'print (1)' >/dev/null 2>/dev/null && echo '1' || echo '0'
		;;		
	cs.messages)
		LOG_LEVEL=$2
		LOG_TYPE=$3
		FILE_NAME="$(echo $LOG_LEVEL)$(echo $LOG_TYPE)_messages.log";
		FILE_NAME_FULL_PATH=/var/lib/cashserver/zabbix-agent/$FILE_NAME;
		echo "DEPRECATED! PLEASE UPDATE YOUR Cashserver3_template!"
		# if [ -s $FILE_NAME_FULL_PATH ]; then
		# 	if cmp --silent $FILE_NAME_FULL_PATH /tmp/TMP_$FILE_NAME; then 
		# 		echo 'LAST'; 
		# 	else 
		# 		echo "$(diff --new-file --unchanged-line-format= --old-line-format= --new-line-format='%L' /tmp/TMP_$FILE_NAME $FILE_NAME_FULL_PATH)"
		# 		cat $FILE_NAME_FULL_PATH > /tmp/TMP_$FILE_NAME; 
		# 	fi; 
		# else 
		# 	rm -f /tmp/TMP_$FILE_NAME; 
		# 	echo OK; 
		# fi;
		;;
	cs.messages.count)
		LOG_LEVEL=$2
		LOG_TYPE=$3
		URI_STRING="http://localhost:8080/CSrest/rest/cashes/log/count?level=$LOG_LEVEL&sortparam=SORT_BY_TIME&type=$LOG_TYPE"
		cs_curl_request $URI_STRING
		echo $CURL_RESULT
		;;
	cs.thread.count)
		THREAD_TYPE=$2
		URI_STRING="http://localhost:8080/CSrest/rest/system/info"
		cs_curl_request $URI_STRING
		jsonval "$CURL_RESULT" $THREAD_TYPE
		echo $JSONVAL_RESULT
		;;
	cs.info.version)
		URI_STRING="http://localhost:8080/CSrest/rest/system/info"
		cs_curl_request $URI_STRING
		jsonval "$CURL_RESULT" buildNumber
		echo $JSONVAL_RESULT
		;;
	cs.info.mode)
		URI_STRING="http://localhost:8080/CSrest/rest/system/mode"
		cs_curl_request $URI_STRING
		jsonval "$CURL_RESULT" hierarhyMode
		echo $JSONVAL_RESULT
		;;
	queues.problems)
		NES_FILE=/var/lib/cashserver/zabbix-agent/errQueues.txt; 
		if [ -f $NES_FILE ]; then 
			if cmp --silent $NES_FILE /tmp/nesLastQueues.txt; then 
				echo 'LAST'; 
			else 
				cat $NES_FILE  > /tmp/nesLastQueues.txt; 
				cat $NES_FILE; 
			fi; 
		else 
			rm -f /tmp/nesLastQueues.txt;
			echo OK; 
		fi;
		;;
	cs.runtime.memory)
		MEMORY_TYPE=$2
		URI_STRING="http://localhost:8080/CSrest/rest/system/runtimeInfo"
		cs_curl_request $URI_STRING
		if [ "$CURL_RESULT" = "0" ]; then
			echo 0;
		else
			jsonval "$CURL_RESULT" $MEMORY_TYPE
			echo $JSONVAL_RESULT
		fi;
		;;
	transfer.lastcopy.discovery)
		items=$($MYSQL "SELECT \`type\` FROM artixcs_struct.last_copy GROUP BY \`type\`"|while read -r line;do echo "{\"{#TYPE}\":\"$(echo $line|awk '{print $1}')\"}";done|tr '\n' ',')
		items=${items::-1}
		echo "{\"data\":[$items]}"
		;;
	transfer.lastcopy.timestamp)
		TABLE=$2
		echo $($MYSQL "SELECT UNIX_TIMESTAMP(MIN(\`last\`)) FROM artixcs_struct.last_copy WHERE \`type\` = \"$TABLE\"")
		;;
esac

