# -*- coding: UTF-8 -*-

'''
Created on 14.06.2013

@author: StarovoytovD
'''

import os, sys, ConfigParser, logging.handlers

config = ConfigParser.RawConfigParser()
configFile = './config.ini'

defaultLogName = 'python_log'

if not config.read(os.path.abspath(configFile)):
    print "Configuration file for logging not found: %s" % os.path.abspath(configFile)
    exit(1)

def getLogger(logName=None):
    if not logName:
        logName = defaultLogName
    logger = logging.getLogger('su.artix.%s' % logName)
    if logger.getEffectiveLevel() != logging.INFO:
        logger = configureLogger(logger, logName)
    return logger

def configureLogger(logger, logName):
    parentDir = config.get('LOG', 'directory')
    logOnConsole = config.getboolean('LOG', 'log_on_console')
    if not os.path.exists(parentDir):
        os.makedirs(parentDir)
    handler = logging.handlers.RotatingFileHandler('%s/%s.log' % (parentDir, logName), maxBytes=500000 , backupCount=15, delay=False)
    formater = logging.Formatter('%(asctime)s %(levelname)-3s %(message)s %(module)5s(%(lineno)s)')
    handler.setFormatter(formater)
    logger.addHandler(handler)
    if logOnConsole:
        handler = logging.StreamHandler(sys.stdout)
        handler.setFormatter(formater)
        logger.addHandler(handler)

    logger.setLevel(logging.DEBUG)
    return logger



